import * as server from '@minecraft/server';
import { world, Player, system } from "@minecraft/server";
const world = server.world
const system = server.system
const Vector = server.Vector

import {
  ActionFormData,
  MessageFormData,
  ModalFormData
} from "@minecraft/server-ui";




world.beforeEvents.itemUse.subscribe(data => {
   let player = data.source
   let item = data.itemStack
    const view = player.getViewDirection();
const viewDirection = player.getViewDirection();
const velocity = player.getVelocity();
const scalar = 1.6;

const scaledViewDirection = {
    x: viewDirection.x * scalar,
    y: viewDirection.y * scalar,
    z: viewDirection.z * scalar
};

const vector = {
    x: scaledViewDirection.x + velocity.x,
    y: scaledViewDirection.y + velocity.y,
    z: scaledViewDirection.z + velocity.z
};

if (item.typeId === "ok:leap") {
    system.run(() => {
        player.runCommandAsync(`clear @s ok:leap 0 1`);
        player.runCommandAsync(`effect @s slow_falling 2 5 true`);
            player.applyKnockback(vector.x, vector.z, Math.hypot(vector.x, vector.z) * 2.3, vector.y < 0.0 ? 0.5 * vector.y : vector.y / 1.05);
            player.runCommandAsync(`playsound mob.enderdragon.flap @a[r=8] ~ ~ ~ 1 1.3`);
            player.runCommandAsync(`particle minecraft:egg_destroy_emitter ~ ~ ~`);
    });
}






if (item.typeId === "ok:highjump") {
    system.run(() => {
        player.runCommandAsync(`clear @s ok:highjump 0 1`);
        player.runCommandAsync(`effect @s levitation 1 15 true`);
        player.runCommandAsync(`effect @s slow_falling 5 10 true`);
        player.runCommandAsync(`playsound note.chime @a[r=5]`);
    });
}

if (item.typeId === "ok:speed") {
    system.run(() => {
        player.runCommandAsync(`clear @s ok:speed 0 1`);
        player.runCommandAsync(`particle minecraft:dragon_dying_explosion ~~1~`);
        player.runCommandAsync(`effect @s speed 1 15 true`);
        player.runCommandAsync(`playsound note.chime @a[r=5]`);
    });
}

if (item.typeId === "ok:rtp") {
    system.run(() => {
        player.runCommandAsync(`clear @s ok:rtp 0 1`);
        player.runCommandAsync(`tp @p[r=1] @r[rm=1]`);
        player.runCommandAsync(`playsound note.chime @a[r=5]`);
        player.runCommandAsync(`particle minecraft:splash_spell_emitter ~~~`);
    });
}


if (item.typeId === "ok:escape") {
    system.run(() => {
        player.runCommandAsync(`clear @s ok:escape 0 1`);
        player.runCommandAsync(`effect @s speed 3 3 true`);
        player.runCommandAsync(`effect @s invisibility 3 3 true`);
        player.runCommandAsync(`effect @a[r=10,rm=1] blindness 2 15 true`);
        player.runCommandAsync(`effect @a[r=10,rm=1] levitation 1 5 true`);
        player.runCommandAsync(`effect @a[r=10,rm=1] nausea 5 5 true`);
        player.runCommandAsync(`playsound note.chime @a[r=5]`);
    });
}

if (item.typeId === "ok:trap") {
    system.run(() => {
        player.runCommandAsync(`clear @s ok:trap 0 1`);
        player.runCommandAsync(`effect @a[r=10,rm=1] blindness 5 15 true`);
        player.runCommandAsync(`effect @a[r=10,rm=1] slowness 5 3 true`);
        player.runCommandAsync(`effect @a[r=10,rm=1] nausea 5 15 true`);
        player.runCommandAsync(`effect @a[r=10,rm=1] fatal_poison 5 15 true`);
        player.runCommandAsync(`execute at @a[r=10,rm=1] run /summon evocation_fang`);
        player.runCommandAsync(`execute at @a[r=10,rm=1] run /summon arrow ~~15~`);
        player.runCommandAsync(`playsound note.chime @a[r=5]`);
    });
}

if (item.typeId === "pa:lightning") {
    system.run(() => {
        player.runCommandAsync(`clear @s pa:lightning 0 1`);
        player.runCommandAsync(`effect @s resistance 1 255 true`);
        player.runCommandAsync(`effect @s fire_resistance 3 255 true`);
        player.runCommandAsync(`execute at @a[r=10,rm=1] run /summon lightning_bolt`);
        player.runCommandAsync(`playsound note.chime @a[r=5]`);
    });
}

if (item.typeId === "ok:freeze") {
    system.run(() => {
        player.runCommandAsync(`clear @s ok:freeze 0 1`);
        player.runCommandAsync(`tag @a[r=10,rm=1] add frozen`);
        player.runCommandAsync(`inputpermission set @a[tag=frozen] movement disabled`);
        player.runCommandAsync(`execute at @a[r=10,rm=1] run /function freeze`);
        player.runCommandAsync(`playsound note.chime @a[r=5]`);
        player.runCommandAsync(`execute at @a[tag=frozen] run /tp @p[tag=frozen,r=1] ~~~`);
        player.runCommandAsync(`gamerule sendcommandfeedback false`);
    });

for (let i = 5; i <= 60; i += 5) {
    system.runTimeout(() => {
        player.runCommandAsync(`gamerule sendcommandfeedback false`);
        player.runCommandAsync(`execute at @a[tag=frozen] run /tp @p[tag=frozen,r=1] ~~~`);
    }, i);
}

    system.runTimeout(() => {
        player.runCommandAsync(`execute at @a[tag=frozen] run /fill ~3~4~3~-3~-3~-3 air replace frosted_ice`);
        player.runCommandAsync(`inputpermission set @a[tag=frozen] movement enabled`);
    }, 60);
}

if (item.typeId === "ok:roar") {
    system.run(() => {
        player.runCommandAsync(`clear @s ok:roar 0 1`);
        player.runCommandAsync(`execute at @s run /particle minecraft:sonic_explosion ^^1^1`);
        player.runCommandAsync(`execute at @s run /particle minecraft:sonic_explosion ^^1^2`);
        player.runCommandAsync(`execute at @s run /particle minecraft:sonic_explosion ^^1^3`);
        player.runCommandAsync(`execute at @s run /particle minecraft:sonic_explosion ^^1^4`);
        player.runCommandAsync(`execute at @s run /particle minecraft:sonic_explosion ^^1^5`);
        player.runCommandAsync(`execute at @s run /damage @a[r=5,rm=1] 6 sonic_boom entity @s`);
        player.runCommandAsync(`playsound note.chime @a[r=5]`);
    });
}




})
